Bug 592443 - Review Request: antlrworks - Grammar development environment for ANTLR v3 grammars
Review Request: antlrworks - Grammar development environment for ANTLR v3 gra...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Stanislav Ochotnicky
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-05-14 17:03 EDT by Mohamed El Morabity
Modified: 2010-06-30 11:19 EDT (History)
3 users (show)

See Also:
Fixed In Version: antlrworks-1.4-4.fc13
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-16 10:55:36 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
sochotni: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Mohamed El Morabity 2010-05-14 17:03:42 EDT
Spec URL: http://melmorabity.fedorapeople.org/packages/antlrworks/antlrworks.spec
SRPM URL: http://melmorabity.fedorapeople.org/packages/antlrworks/antlrworks-1.4-1.fc12.src.rpm
Description:
ANTLRWorks is a novel grammar development environment for ANTLR v3 grammars
written by Jean Bovet (with suggested use cases from Terence Parr). It combines
an excellent grammar-aware editor with an interpreter for rapid prototyping and
a language-agnostic debugger for isolating grammar errors. ANTLRWorks helps
eliminate grammar nondeterminisms, one of the most difficult problems for
beginners and experts alike, by highlighting nondeterministic paths in the
syntax diagram associated with a grammar. ANTLRWorks' goal is to make grammars
more accessible to the average programmer, improve maintainability and
readability of grammars by providing excellent grammar navigation and
refactoring tools, and address the most common questions and problems
encountered by grammar developers.


rpmlint outputs:

$ rpmlint antlrworks-1.4-1.fc12.src.rpm 
antlrworks.src: W: spelling-error %description -l en_US nondeterminisms -> determinism, deterministic, indeterminably
antlrworks.src: W: spelling-error %description -l en_US nondeterministic -> non deterministic, non-deterministic, deterministic
antlrworks.src: W: spelling-error %description -l en_US refactoring -> re factoring, re-factoring, factoring

$ rpmlint antlrworks-1.4-1.fc12.noarch.rpm
antlrworks.noarch: E: devel-dependency java-devel
antlrworks.noarch: W: spelling-error %description -l en_US nondeterminisms -> determinism, deterministic, indeterminably
antlrworks.noarch: W: spelling-error %description -l en_US nondeterministic -> non deterministic, non-deterministic, deterministic
antlrworks.noarch: W: spelling-error %description -l en_US refactoring -> re factoring, re-factoring, factoring

About the java-devel Requires: antlrworks calls javac to compile grammars.
Comment 1 Stanislav Ochotnicky 2010-06-03 08:28:28 EDT
I can do the review.
Comment 2 Stanislav Ochotnicky 2010-06-03 08:31:44 EDT
Before I start official review...Spec file you lined to and spec file inside SRPM don't match. Fix this please.
Comment 3 Stanislav Ochotnicky 2010-06-03 10:37:38 EDT
Ah well...I checked spec differences and they were cosmetic, but please be more careful next time :-)

OK: rpmlint must be run on every package. The output should be posted in the 
antlrworks.src: W: spelling-error %description -l en_US nondeterminisms -> determinism, deterministic, indeterminably
antlrworks.src: W: spelling-error %description -l en_US nondeterministic -> non deterministic, non-deterministic, deterministic
antlrworks.src: W: spelling-error %description -l en_US refactoring -> re factoring, re-factoring, factoring
antlrworks.noarch: E: devel-dependency java-devel
antlrworks.noarch: W: spelling-error %description -l en_US nondeterminisms -> determinism, deterministic, indeterminably
antlrworks.noarch: W: spelling-error %description -l en_US nondeterministic -> non deterministic, non-deterministic, deterministic
antlrworks.noarch: W: spelling-error %description -l en_US refactoring -> re factoring, re-factoring, factoring
antlrworks.noarch: W: no-manual-page-for-binary antlrworks
2 packages and 0 specfiles checked; 1 errors, 7 warnings.

You explained the devel dependency and it's OK.

OK: The package must be named according to the Package Naming Guidelines .
OK: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.  .
OK: The package must meet the Packaging Guidelines .
OK: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
OK: The License field in the package spec file must match the actual license. 
OK: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
OK: The spec file must be written in American English. 
OK: The spec file for the package MUST be legible. 
OK: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
OK(mock): The package MUST successfully compile and build into binary rpms on at least one primary architecture. 
OK: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
OK: Packages must NOT bundle copies of system libraries.
OK: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. 
OK: A Fedora package must not list a file more than once in the spec file's %files listings. 
OK: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. 
OK: Each package must consistently use macros. 
OK: The package must contain code, or permissable content. 
OK: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). 
NEEDSWORK: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. 

You have to use desktop-file-install, not just desktop-file-validate
since you are installing the file yourself.  You also have to Require
hicolor-icon-theme since you are using its directories.

OK: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. 
OK: All filenames in rpm packages must be valid UTF-8. 


Other:
 * patch1 has a small typo for suffix "browers" :-)
 * readme and release.txt should not be included the way they are because
   changes in upstream would never appear in the package on their
   own (caused by caching on Fedora dist servers). I would strongly
   advise working with upstream to provide these files inside release
   tarballs/zips. Or alternatively provide versioned release notes. In
   the meantime, just don't ship these (or just ship readme.txt), they
   will be useless on next release.
Comment 4 Mohamed El Morabity 2010-06-03 12:57:16 EDT
Thanks for your review, and sorry for the discordance between the .spec file and the SRPM, I thought I uploaded the good SRPM for the review. It should be OK now.

Here are the new .spec and SRPM with all your suggestions:
Spec URL:
http://melmorabity.fedorapeople.org/packages/antlrworks/antlrworks.spec
SRPM URL:
http://melmorabity.fedorapeople.org/packages/antlrworks/antlrworks-1.4-2.fc13.src.rpm
Comment 5 Stanislav Ochotnicky 2010-06-04 03:45:57 EDT
Package seems good, but you could have called desktop-file-install directly with SOURCE2. No need to first install it to RPM_BUILD_ROOT.

And please get in touch with upstream and work with them to include readme, release notes etc in the package. While they are at it, they should also have COPYING/LICENSE file there so it's easier to evaluate what is the package license.

This package is APPROVED.
Comment 6 Mohamed El Morabity 2010-06-04 07:34:22 EDT
New Package CVS Request
=======================
Package Name: antlrworks
Short Description: Grammar development environment for ANTLR v3 grammars
Owners: melmorabity
Branches: F-11 F-12 F-13
InitialCC:
Comment 7 Kevin Fenzi 2010-06-07 16:54:44 EDT
CVS done (by process-cvs-requests.py).

With the release of Fedora 13 we no longer allow F-11 branches.
Comment 8 Fedora Update System 2010-06-12 10:27:15 EDT
antlrworks-1.4-4.fc13 has been submitted as an update for Fedora 13.
http://admin.fedoraproject.org/updates/antlrworks-1.4-4.fc13
Comment 9 Fedora Update System 2010-06-12 10:45:03 EDT
antlrworks-1.4-4.fc12 has been submitted as an update for Fedora 12.
http://admin.fedoraproject.org/updates/antlrworks-1.4-4.fc12
Comment 10 Fedora Update System 2010-06-14 13:12:23 EDT
antlrworks-1.4-4.fc12 has been pushed to the Fedora 12 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update antlrworks'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/antlrworks-1.4-4.fc12
Comment 11 Fedora Update System 2010-06-14 13:16:00 EDT
antlrworks-1.4-4.fc13 has been pushed to the Fedora 13 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update antlrworks'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/antlrworks-1.4-4.fc13
Comment 12 Stanislav Ochotnicky 2010-06-16 10:55:36 EDT
What is the reason to put new package into updates? There is no such requirement and I would strongly encourage you not to do this again. You are just adding work for people who have to move this package to testing and then stable. No one is using this package yet so this is completely useless.

Closing this bug for you. Next time please instead of going through bodhi, just close this bug with link to koji build in the comment.
Comment 13 Fedora Update System 2010-06-30 11:12:10 EDT
antlrworks-1.4-4.fc12 has been pushed to the Fedora 12 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 14 Fedora Update System 2010-06-30 11:19:24 EDT
antlrworks-1.4-4.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.